import { world, system, BlockPermutation } from "@minecraft/server"

//world.sendMessage("Script Online!");

/*world.afterEvents.entityHitEntity.subscribe(function(data) {
    if ((data.damagingEntity.typeId == "zpig:herobrine") && (data.damagingEntity.getComponent("skin_id").value == 0)) {
        data.damagingEntity.runCommand("event entity @s zpig:leave_short");
    }
});*/

let playerTorches = [];
let herobrineTorches = [];
let herobrineSigns = [];

//let herobrineSummonCount = 0;

let herobrineListOverworld = world.getDimension("overworld").getEntities({type: 'zpig:herobrine',});
let herobrineListNether = world.getDimension("nether").getEntities({type: 'zpig:herobrine',});
let herobrineListEnd = world.getDimension("the_end").getEntities({type: 'zpig:herobrine',});
let herobrineList = herobrineListOverworld.concat(herobrineListNether, herobrineListEnd);

function updateHerobrineList() {
    const herobrineListOverworldNew = world.getDimension("overworld").getEntities({type: 'zpig:herobrine',});
    const herobrineListNetherNew = world.getDimension("nether").getEntities({type: 'zpig:herobrine',});
    const herobrineListEndNew = world.getDimension("the_end").getEntities({type: 'zpig:herobrine',});
    const herobrineListNew = herobrineListOverworldNew.concat(herobrineListNetherNew, herobrineListEndNew);
    herobrineList = herobrineListNew;
    //world.sendMessage("herobrineList.length: " + herobrineList.length);
}

function summonHerobrine(player, count, mode) {
    //world.sendMessage("herobrineList.length: " + herobrineList.length);
    if ((player.dimension.id == "minecraft:overworld") && (herobrineList.length < 1)) {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 25;
        const minDistance = 10;
        const spawnProbability = 0.65;
        let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        
        const validY = getValidYCoordinate(player, randomX, randomZ);
        let closestDistance = Infinity;
        for (const aPlayer of world.getPlayers()) {
            const playerPosition = aPlayer.location;
            const distance = Math.sqrt(
                Math.pow(playerPosition.x - randomX, 2) +
                Math.pow(playerPosition.y - validY, 2) +
                Math.pow(playerPosition.z - randomZ, 2)
            );
            if (distance < closestDistance) {
                closestDistance = distance;
            }
        }
        if (((closestDistance >= minDistance) && (Math.random() <= spawnProbability)) || ((closestDistance >= minDistance) && (mode > 0))) {
            if (validY !== null) {
                const randomInt = Math.random();
                if ((randomInt <= 0.75) && (mode <= 1)) {
                    player.runCommand(`summon zpig:herobrine ${randomX} ${validY} ${randomZ}`);
                }
                else if ((randomInt > 0.75) && (mode <= 1)) {
                    player.dimension.spawnEntity("zpig:herobrine<zpig:mode_2>", { x: randomX, y: validY, z: randomZ });
                    //world.sendMessage("Herobrine Attack Mode Was Summoned.");
                }
                else if (mode == 2) {
                    player.runCommand(`summon zpig:herobrine ${randomX} ${validY} ${randomZ}`);
                }
                else if (mode >= 3) {
                    player.dimension.spawnEntity("zpig:herobrine<zpig:mode_2>", { x: randomX, y: validY, z: randomZ });
                }
                //herobrineSummonCount++;
                //world.sendMessage("Herobrine Was Summoned.");
            }
            else    {
                if (count < 5) {
                    count++;
                    //world.sendMessage("count: " + count);
                    summonHerobrine(player, count);
                }
                //world.sendMessage("Not A Suitable Spawn Location For Herobrine.");
            }
        }
        //else
            //world.sendMessage("Herobrine Was Not Summoned.");
    }
    //else
            //world.sendMessage("Herobrine Is Already In The World.");
}

function writeMessage(player, mode) {
    if (player.dimension.id == "minecraft:overworld") {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 15;
        const minDistance = 10;
        const spawnProbability = 0.6;
        let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        
        const validY = getValidYCoordinateForSign(player, randomX, randomZ);
        let closestDistance = Infinity;
        for (const aPlayer of world.getPlayers()) {
            const playerPosition = aPlayer.location;
            const distance = Math.sqrt(
                Math.pow(playerPosition.x - randomX, 2) +
                Math.pow(playerPosition.y - validY, 2) +
                Math.pow(playerPosition.z - randomZ, 2)
            );
            if (distance < closestDistance) {
                closestDistance = distance;
            }
        }
        if (((closestDistance >= minDistance) && (Math.random() <= spawnProbability)) || ((closestDistance >= minDistance) && (mode > 0))) {
            if (validY !== null) {
                const block = world.getDimension("overworld").getBlock({ x: randomX, y: validY, z: randomZ });
                block.setPermutation(BlockPermutation.resolve("minecraft:standing_sign"));
                const sign = block.getComponent("minecraft:sign");

                const randomNum = Math.random();
                if (randomNum < 0.02) {
                    sign.setText("I am sorry, " + player.name + "...");
                } else if (randomNum < 0.1625) {
                    sign.setText("Do you know who I am?");
                } else if (randomNum < 0.305) {
                    sign.setText("You should not be here.");
                } else if (randomNum < 0.4475) {
                    sign.setText("Get out while you can.");
                } else if (randomNum < 0.59) {
                    sign.setText("You cannot stop it, " + player.name + ".");
                } else if (randomNum < 0.7325) {
                    sign.setText("Do not turn around.");
                } else if (randomNum < 0.875) {
                    sign.setText("You must leave.");
                } else {
                    sign.setText("I am watching you, " + player.name + ".");
                }

                herobrineSigns.push(block);

                //world.sendMessage("Herobrine's Sign Placed.");
            }
            /*else
                world.sendMessage("Not A Suitable Location For Herobrine's Sign.");*/
        }
        //else
            //world.sendMessage("Herobrine's Sign Was Not Placed.");
    }
}

function torchDeepslate(player, mode) {
    if ((player.dimension.id == "minecraft:overworld")) {
        //world.sendMessage("player.dimension.id: " + player.dimension.id);
        const spawnRadius = 6;
        const minDistance = 4;
        const spawnProbability = 0.005;
        let randomX, randomZ;
            do {
                randomX = Math.floor(player.location.x + (Math.random() * 2 - 1) * spawnRadius);
                randomZ = Math.floor(player.location.z + (Math.random() * 2 - 1) * spawnRadius);
            } while (Math.sqrt(Math.pow(randomX - player.location.x, 2) + Math.pow(randomZ - player.location.z, 2)) < minDistance);
        
        const validY = getValidYCoordinateTorchDeepslate(player, randomX, randomZ);
        let closestDistance = Infinity;
        for (const aPlayer of world.getPlayers()) {
            const playerPosition = aPlayer.location;
            const distance = Math.sqrt(
                Math.pow(playerPosition.x - randomX, 2) +
                Math.pow(playerPosition.y - validY, 2) +
                Math.pow(playerPosition.z - randomZ, 2)
            );
            if (distance < closestDistance) {
                closestDistance = distance;
            }
        }
        if (((closestDistance >= minDistance) && (Math.random() <= spawnProbability)) || ((closestDistance >= minDistance) && (mode > 0))) {
            if (validY !== null) {
                const block = player.dimension.getBlock({ x: randomX, y: validY, z: randomZ });
                block.setPermutation(BlockPermutation.resolve("minecraft:redstone_torch"));
                world.playSound("mob.herobrine.place_torch_deepslate", block.location);
                herobrineTorches.push(block);
                //world.sendMessage("Herobrine's Torch Placed.");
            }
            //else
                //world.sendMessage("Not A Suitable Spawn Location For Herobrine's Torch.");
        }
        /*else
            world.sendMessage("Herobrine's Torch Was Not Summoned.");*/
    }
}

function getValidYCoordinateTorchDeepslate(player, xLocation, zLocation) {
    const range = 2;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            const blockBelow = player.dimension.getBlock({ x: xLocation, y: y - 1, z: zLocation });
            const blockEast = player.dimension.getBlock({ x: xLocation + 1, y: y, z: zLocation });
            const blockWest = player.dimension.getBlock({ x: xLocation - 1, y: y, z: zLocation });
            const blockNorth = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation - 1 });
            const blockSouth = player.dimension.getBlock({ x: xLocation, y: y, z: zLocation + 1 });
            if ((!blockAbove.isAir && !blockAbove.isLiquid) && (!blockBelow.isAir && !blockBelow.isLiquid) && (!blockEast.isAir && !blockEast.isLiquid) && (!blockWest.isAir && !blockWest.isLiquid) && (!blockNorth.isAir && !blockNorth.isLiquid) && (!blockSouth.isAir && !blockSouth.isLiquid) && (blockAtPosition.typeId == "minecraft:deepslate")) {
                return y;
            }
        }
    }
    return null;
}

function getValidYCoordinateForSign(player, xLocation, zLocation) {
    const range = 10;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            if ((!blockAtPosition.isAir && !blockAtPosition.isLiquid) && blockAbove.isAir) {
                return y + 1;
            }
        }
    }
    return null;
}

function getValidYCoordinate(player, xLocation, zLocation) {
    const range = 8;
    let adjustedYOffset = 0;
    for (let yOffset = 0; yOffset <= range * 2; yOffset++) {
        if (yOffset == 1 && adjustedYOffset >= 0) {
            adjustedYOffset = -1;
        } else {
            if (adjustedYOffset <= 0) {
                adjustedYOffset = Math.abs(adjustedYOffset);
            } else {
                adjustedYOffset = -adjustedYOffset - 1;
            }
        }
        //world.sendMessage("adjustedYOffset: " + adjustedYOffset);
        const y = Math.floor(player.location.y) + adjustedYOffset;
        if (y >= -64 && y <= 320) {
            const blockLocation = { x: xLocation, y: y, z: zLocation };
            const blockAtPosition = player.dimension.getBlock(blockLocation);
            const blockAbove = player.dimension.getBlock({ x: xLocation, y: y + 1, z: zLocation });
            const blockAbove2 = player.dimension.getBlock({ x: xLocation, y: y + 2, z: zLocation });
            if ((!blockAtPosition.isAir && !blockAtPosition.isLiquid) && blockAbove.isAir && blockAbove2.isAir) {
                return y + 1;
            }
        }
    }
    return null;
}

function deleteTorch() {
    const probability = 0.75;
    if (Math.random() <= probability)
        playerTorches[Math.floor(Math.random() * playerTorches.length)].setPermutation(BlockPermutation.resolve("minecraft:air"));
}

let deepslateTorchPlayer;
let runDeepslateTorch = false;

system.runInterval(() => {
    for (const player of world.getPlayers()) {
        if (player.isSleeping && (!player.hasTag("zpig:sleeping"))) {
            player.addTag("zpig:sleeping");
            //player.sendMessage("Good Night.");
            const probability = 0.4;
            if (((world.getDay() >= 3) && (Math.random() <= probability)) || (player.hasTag("zpig:summon_herobrine_nightmare_function"))) {
                player.dimension.spawnEntity("zpig:herobrine_nightmare_setup_entity", player.location);
            }
            //world.sendMessage("world.gameRules.sendCommandFeedback: " + world.gameRules.sendCommandFeedback);
        }
        if (!player.isSleeping && (player.hasTag("zpig:sleeping")) && !(player.hasTag("zpig:victim_setup") || player.hasTag("zpig:victim"))) {
            player.runCommand("stopsound @s");
            player.removeTag("zpig:sleeping");
            player.runCommand("event entity @e [type=zpig:herobrine,c=1,tag=zpig:herobrine_nightmare_start] zpig:leave_short");
        }
        if (player.hasTag("zpig:victim_setup")) {
            player.addTag("zpig:victim");
            player.removeTag("zpig:victim_setup");
            player.removeTag("zpig:summon_herobrine_nightmare_function");
            if (!world.gameRules.sendCommandFeedback) {
                player.runCommand("tp @s ~ ~ ~ facing @e [type=zpig:herobrine,c=1]");
            }
            else {
                world.gameRules.sendCommandFeedback = false;
                player.runCommand("tp @s ~ ~ ~ facing @e [type=zpig:herobrine,c=1]");
                world.gameRules.sendCommandFeedback = true;
            }
        }
        if (player.hasTag("zpig:summon_herobrine_function")) {
            player.removeTag("zpig:summon_herobrine_function");
            summonHerobrine(player, 0, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_stalk_function")) {
            player.removeTag("zpig:summon_herobrine_stalk_function");
            summonHerobrine(player, 0, 2);
        }
        if (player.hasTag("zpig:summon_herobrine_attack_function")) {
            player.removeTag("zpig:summon_herobrine_attack_function");
            summonHerobrine(player, 0, 3);
        }
        if (player.hasTag("zpig:summon_herobrine_sign_function")) {
            player.removeTag("zpig:summon_herobrine_sign_function");
            writeMessage(player, 1);
        }
        if (player.hasTag("zpig:summon_herobrine_torch_deepslate_function")) {
            player.removeTag("zpig:summon_herobrine_torch_deepslate_function");
            torchDeepslate(player, 1);
        }
        if (player.hasTag("zpig:remove_random_torch")) {
            player.removeTag("zpig:remove_random_torch");
            deleteTorch();
        }
    }
    for (const player of world.getPlayers()) {

        const entitiesInView = player.getEntitiesFromViewDirection();
    
        entitiesInView.forEach((hit) => {
            if (hit.entity.typeId == "zpig:herobrine") {
                if (hit.entity.getComponent("skin_id").value == 1) {
                    player.runCommand("playsound ambient.cave @s");
                    hit.entity.runCommand("event entity @s zpig:leave_short");
                }
                else if (hit.entity.getComponent("skin_id").value == 2) {
                    hit.entity.runCommand("event entity @s zpig:mode_2_attack");
                    hit.entity.addTag("zpig:herobrine_attacking");
                    player.runCommand("playsound mob.endermen.scream @s ~ ~ ~ 25 0.6");
                    player.runCommand("tp @e [type=zpig:herobrine,tag=zpig:herobrine_attacking,c=1] ^ ^ ^0.4 facing @s");
                }
            }
        });
    }
    for (const torch of playerTorches) {
        if (torch.typeId != "minecraft:torch") {
            playerTorches.splice(playerTorches.indexOf(torch), 1);
            //world.sendMessage("Torch Broken.");
            //world.sendMessage("playerTorches.length: " + playerTorches.length);
        }
    }
    for (const torch of herobrineTorches) {
        if (torch.typeId != "minecraft:redstone_torch") {
            herobrineTorches.splice(herobrineTorches.indexOf(torch), 1);
            //world.sendMessage("Herobrine's Torch Broken.");
            world.playSound("ambient.cave", torch.location);
            //world.sendMessage("herobrineTorches.length: " + herobrineTorches.length);
        }
    }
    for (const sign of herobrineSigns) {
        if (sign.typeId != "minecraft:standing_sign") {
            herobrineSigns.splice(herobrineSigns.indexOf(sign), 1);
            //world.sendMessage("Herobrine's Sign Broken.");
            world.playSound("ambient.cave", sign.location);
            //world.sendMessage("herobrineSigns.length: " + herobrineSigns.length);
        }
    }
    if (runDeepslateTorch) {
        runDeepslateTorch = false;
        torchDeepslate(deepslateTorchPlayer, 0);
    }
    updateHerobrineList();
});

world.afterEvents.playerPlaceBlock.subscribe(function(data) {
    if (data.block.typeId == "minecraft:torch") {
        playerTorches.push(data.block);
        //world.sendMessage("Torch Placed.");
        //world.sendMessage("playerTorches.length: " + playerTorches.length);
    }
})

world.beforeEvents.playerBreakBlock.subscribe(function(data) {
    if ((data.block.typeId == "minecraft:deepslate") || (data.block.typeId == "minecraft:deepslate_coal_ore") || (data.block.typeId == "minecraft:deepslate_copper_ore") || (data.block.typeId == "minecraft:deepslate_diamond_ore") || (data.block.typeId == "minecraft:deepslate_emerald_ore") || (data.block.typeId == "minecraft:deepslate_gold_ore") || (data.block.typeId == "minecraft:deepslate_iron_ore") || (data.block.typeId == "minecraft:deepslate_lapis_ore") || (data.block.typeId == "minecraft:deepslate_redstone_ore")) {
        //world.sendMessage("Deepslate Block Broken.");
        //world.sendMessage("data.player.name: " + data.player.name);
        deepslateTorchPlayer = data.player;
        runDeepslateTorch = true;
    }
})

/*world.afterEvents.buttonPush.subscribe(function(data) {
    world.sendMessage("Herobrine has been spawned " + herobrineSummonCount + " times.");
    if (herobrineList.length > 0)
        world.sendMessage("He's still here, actually.");
    else if (herobrineSummonCount > 0)
        world.sendMessage("Haven't you seen him?");
})*/

function choosePlayerToSummonHerobrine() {
    const player = world.getPlayers()[Math.floor(Math.random() * world.getPlayers().length)]
    summonHerobrine(player, 0, 0);
}

function choosePlayerToPlaceHerobrineSign() {
    const player = world.getPlayers()[Math.floor(Math.random() * world.getPlayers().length)]
    writeMessage(player, 0);
}

system.runInterval(choosePlayerToSummonHerobrine, 1200);

system.runInterval(deleteTorch, 6000);

system.runInterval(choosePlayerToPlaceHerobrineSign, 12000);

//choosePlayerToSummonHerobrine();

//world.sendMessage("Script End.");